/*
	$Id: GlobalVariable.java 175 2006-04-23 16:08:10Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import org.w3c.dom.Element;
import java.io.PrintWriter;

/**
   ХѿǤ

   globalVariableǤбޤ
*/
public class GlobalVariable {

    /** type° */
    private String type;

    /** name° */
    private String name;

    /** descǤ */
    private Description desc;

    /**
       Хѿޤ

       @param elem method
    */
    public GlobalVariable(final Element elem) {
	name = elem.getAttribute("name");
	type = elem.getAttribute("type");

	ChildrenFilter c = new ChildrenFilter(elem);
	desc = new Description(c.getDirectChildrenByTagName("desc"));
    }

    /**
       name°ͤޤ

       @return name°
    */
    public String getName() {
	return name;
    }

    /**
       Хѿηɽʸޤ

       @return Хѿηɽʸ
    */
    private String getTypeText() {
	if (type.indexOf('#') != -1) {
	    return type.replaceFirst("#", "");
	}
	return type;
    }

    /**
       ƬꤷƥɤϤޤ

       @param wr 饤
       @param prefix Ƭ
    */
    private void printCode(final PrintWriter wr, final String prefix) {
	if (type.indexOf('#') != -1) {
	    wr.println(prefix + type.replaceFirst("#", name) + ";");
	} else {
	    wr.println(prefix + type + " " + name + ";");
	}
    }

    /**
       ɤϤޤ

       @param wr 饤
    */
    public void printCode(final PrintWriter wr) {
	printCode(wr, "extern ");
    }

    /**
       ֤ΥإåϤޤ

       @param wr 饤
    */
    public void printStubHeader(final PrintWriter wr) {
	printCode(wr);
    }

    /**
       ֤ΥɤϤޤ

       @param wr 饤
    */
    public void printStubCode(final PrintWriter wr) {
	printCode(wr, "");
    }

    /**
       HTMLǽϤޤ

       @param wr 饤
    */
    public void printSummary(final PrintWriter wr) {
	IDManager m = IDManager.getInstance();

	wr.println(""
+ "<tr>\n"
+ "  <td align=\"right\" valign=\"top\" width=\"1%\">\n"
+ "    <font size=\"-1\">&nbsp;" + m.getString(getTypeText())
+ "</font>\n"
+ "  </td>\n"
+ "  <td valign=\"top\">"
+ "<a href=\"#" + name + "\"><b>" + name + "</b></a>" + "<br>"
+ "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"
+ desc.getBriefText() + "</td>\n"
+ "</tr>");
    }

    /**
       ܺ٤HTMLǽϤޤ

       @param wr 饤
    */
    public void printDetail(final PrintWriter wr) {
	IDManager m = IDManager.getInstance();
	String leftType, rightType;
	int k = type.indexOf('#');

	if (k == -1) {
	    leftType = type;
	    rightType = "";
	} else {
	    leftType = type.substring(0, k);
	    rightType = type.substring(k + 1);
	}

	wr.print(""
+ "<p><a name=\"" + name + "\"></a>"
+ "<font size=\"+1\"><b>" + name + "</b></font></p>\n"
+ "<table cellpadding=\"0\" cellspacing=\"0\">\n"
+ "  <tr>\n"
+ "    <td nowrap>" + m.getString(leftType)
		    + " <b>" + name + "</b>"
		    + m.getString(rightType)
		    + "</td>\n"
+ "  </tr>\n"
+ "</table>\n"
+ "<dl>\n"
+ "<dd>" + desc.getText() + "</dd>\n");

	wr.println(""
+ "</dl>");
    }

    /**
       ܺ٤TeXǽϤޤ

       @param wr 饤
    */
    public void printTexDetail(final PrintWriter wr) {
	String texName = Tex.safe(name);
	String leftType, rightType;
	int k = type.indexOf('#');

	if (k == -1) {
	    leftType = type;
	    rightType = "";
	} else {
	    leftType = type.substring(0, k);
	    rightType = type.substring(k + 1);
	}
	leftType = Tex.safe(leftType);
	rightType = Tex.safe(rightType);

	// Syntax
	wr.println("");
	wr.println("\\Sid{" + texName + "}");
	wr.println("\\nopagebreak");
	wr.println("\\begin{Ssyntax}%");
	wr.println(leftType + " {\\bfseries " + texName + "}" + rightType);
	wr.println("\\end{Ssyntax}");

	// Description
	wr.print(desc.getTexText());
    }
}
